/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : WCH
* Version            : V1.1
* Date               : 2020/12/23
* Description 		 : 
*******************************************************************************/
#include "CH56x_common.h"


/* Global define */
#define UART1_BAUD  921600

/* Global Variable */



/* Function declaration */



/*******************************************************************************
* Function Name  : DebugInit
* Description    : Initializes the UART1 peripheral.
* Input          : baudrate: UART1 communication baud rate.
* Return         : None
*******************************************************************************/
void DebugInit(UINT32 baudrate)
{
	UINT32 x;
	UINT32 t = FREQ_SYS;
	x = 10 * t * 2 / 16 / baudrate;
	x = ( x + 5 ) / 10;
	R8_UART1_DIV = 1;
	R16_UART1_DL = x;
	R8_UART1_FCR = RB_FCR_FIFO_TRIG | RB_FCR_TX_FIFO_CLR | RB_FCR_RX_FIFO_CLR | RB_FCR_FIFO_EN;
	R8_UART1_LCR = RB_LCR_WORD_SZ;
	R8_UART1_IER = RB_IER_TXD_EN;
	R32_PA_SMT |= (1<<8) |(1<<7);
	R32_PA_DIR |= (1<<8);
}
const UINT8 test_1[1024*160] = {0xFF};
/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main()
{

    UINT32 i = 0xFF00;
    UINT8 val = 1;

    SystemInit(FREQ_SYS);
	Delay_Init(FREQ_SYS);

/* ôڵ */
	DebugInit(UART1_BAUD);
	PRINT("UER APP !\n");
	i = 0xFF00;
	val = i<<8;
    GPIOB_ModeCfg( GPIO_Pin_24, GPIO_Slowascent_PP_8mA );

    if( R8_GLOB_RESET_KEEP == 0xAA )
    {
        printf( "User Code Confirmed" );
    }

    /* Ҫû룬ִ² */
#if 0
    printf( "Jump to IAP!" );
    /* ձ־ */
    R8_GLOB_RESET_KEEP = 0x00;
    /* λ */
    SYS_ResetExecute( );
#endif
    while(1)
    {
        i++;
        GPIOB_ResetBits(GPIO_Pin_24);
        mDelaymS(300);
        GPIOB_SetBits(GPIO_Pin_24);
        mDelaymS(300);
    }
}
