/********************************** (C) COPYRIGHT *******************************
* File Name          : CH56x_usb20.c
* Author             : WCH
* Version            : V1.1
* Date               : 2020/12/23
* Description        :
*******************************************************************************/
#include "CH56x_common.h"

#include "CH56x_usb20.h"

/* Global define */


/* Global Variable */

__attribute__ ((aligned(16))) UINT8  endp0RTbuff[64] __attribute__((section(".DMADATA"))); //ݷ/ջ
__attribute__ ((aligned(16))) UINT8  endp2RTbuff[64] __attribute__((section(".DMADATA"))); //ݷ/ջ
__attribute__ ((aligned(16))) UINT8  endp3RTbuff[8] __attribute__((section(".DMADATA"))); //ݷ/ջ

UINT8 initial_end;
UINT8 set_address_status =0;
UINT8 get_config_status =0;
UINT8 device_addr;

/* Function declaration */
void USBHS_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));           //USB2.0 interrupt service

const UINT8 hs_device_descriptor[] =
{
    0x12, 0x01, 0x10, 0x01,
    0xFF, 0x80, 0x55, 0x40,
    0x48, 0x43, 0x37, 0x55,
    0x00, 0x01, 0x00, 0x00,
    0x01, 0x01
};

const UINT8 hs_config_descriptor[] =
{
    0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
    0x09, 0x04, 0x00, 0x00, 0x02, 0xFF, 0x80, 0x55, 0x00,
    0x07, 0x05, 0x83, 0x02, 0x08, 0x00, 0x00,
    0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00
};
// ====================================
// ===== String Descriptor Lang ID=====
// ====================================
const UINT8 hs_string_descriptor0[] =
{
        0x04, 0x03, 0x09, 0x04
};
// ====================================
// =====   String Descriptor 1    =====
// ====================================
const UINT8 hs_string_descriptor1[] =
{
        0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0
};
// ====================================
// =====   String Descriptor 2    =====
// ====================================
const UINT8 hs_string_descriptor2[]=
{
        0x0C, 0x03, 'C', 0, 'H', 0, '5', 0, '6', 0, 'x', 0
};

/*******************************************************************************
* Function Name  : USB20_Endp_Init
* Description    : USB2.0˵ʼ
* Input          : None
* Return         : None
*******************************************************************************/
void USB20_Endp_Init ()	// USBHS device endpoint initial
{
	USBHS->USB_BUF_MODE = 0xccccccc;
	USBHS->UEP0_MAX_LEN = 64;
	USBHS->UEP1_MAX_LEN = 512;
	USBHS->UEP2_MAX_LEN = 512;
	USBHS->UEP3_MAX_LEN = 512;
	USBHS->UEP4_MAX_LEN = 512;
	USBHS->UEP5_MAX_LEN = 512;
	USBHS->UEP6_MAX_LEN = 512;
	USBHS->UEP7_MAX_LEN = 512;

	USBHS->UEP0_DMA    = (UINT32)(UINT8 *)endp0RTbuff;
	USBHS->UEP2_TX_DMA = (UINT32)(UINT8 *)endp2RTbuff;
	USBHS->UEP2_RX_DMA = (UINT32)(UINT8 *)endp2RTbuff;
	USBHS->UEP3_TX_DMA = (UINT32)(UINT8 *)endp3RTbuff;
	USBHS->UEP3_RX_DMA = (UINT32)(UINT8 *)endp3RTbuff;

	USBHS->UEP0_CTRL = 0;
	USBHS->UEP1_CTRL = 0x20200000;
	USBHS->UEP2_CTRL = 0x20200000;
	USBHS->UEP3_CTRL = EP_T_TOG_0|EP_T_RES_NAK|0;
	USBHS->UEP4_CTRL = 0x20200000;
	USBHS->UEP5_CTRL = 0x20200000;
	USBHS->UEP6_CTRL = 0x20200000;
	USBHS->UEP7_CTRL = 0x20200000;

}
/*******************************************************************************
* Function Name  : USB20_Device_Init
* Description    : USB2.0豸ʼ
* Input          : ENABLEʹ   DISABLEر
* Return         : None
*******************************************************************************/
void USB20_Device_Init ( FunctionalState sta )  // USBSS device initial
{
    if(sta){
        USB20_Endp_Init();
        USBHS->USB_CONTROL = 0;
        USBHS->USB_CONTROL =  FULL_SPEED | INT_BUSY_EN | DMA_EN | DEV_PU_EN | USB2_SETUP_EN | USB2_ACT_EN | USB2_DETECT_EN | USB2_SUSP_EN;
    }
    else{
        USBHS->USB_CONTROL = USB_ALL_CLR | USB_FORCE_RST;
    }
}

/*******************************************************************************
* Function Name  : USB20_Device_setaddress
* Description    : USB2.0豸ַ
* Input          : ַ
* Return         : None
*******************************************************************************/
void USB20_Device_Setaddress( UINT32 address )
{
    USBHS->USB_CONTROL &= 0x00ffffff;
    USBHS->USB_CONTROL |= address<<24; // SET ADDRESS
}

BOOL P_tog = 1;
/*******************************************************************************
* Function Name  : ch569_iap_respond
* Description    : 569 iap respond
* Input          : ַ
* Return         : None
*******************************************************************************/
void ch569_iap_respond( UINT8 s )
{
    endp3RTbuff[0] = s;
    endp3RTbuff[1] = 0;
    USBHS->UEP3_CTRL = (P_tog?EP_R_TOG_0:EP_T_TOG_1)|EP_T_RES_ACK|2;
    P_tog = !P_tog;
}
#define USER_ProgrameStartAddr    (0x1000)
#define USER_ProgrameEndAddr      (0x67000)
#define UESR_SEQ_ADDR             (0x6FF00)
__attribute__ ((aligned(16))) UINT8 iap_buf[64];
BOOL iap_flag    = 0;
#define iap_p_prog    ((pmiap_cmd_program)(iap_buf))
#define iap_p_erase   ((pmiap_cmd_erase)(iap_buf))
#define iap_p_end     ((pmiap_cmd_end)(iap_buf))
#define iap_p_verify  ((pmiap_cmd_verify)(iap_buf))
#define iap_p_oth     ((pmiap_cmd_other)(iap_buf))

UINT16 prog_count = 0;
UINT16 vrfy_count = 0;
BOOL   stay_to_check;
BOOL   iap_end = 0;
UINT32 addr_last;
/* ־Удλ0x6FF00 */
const UINT8 req_queue[24] = {24,03,99,0,104,0,53,0,54,0,57,0,105,0,97,0,112,0,49,0,118,0,48,0};

/*******************************************************************************
* Function Name  : CH559_USB_ISPDownload
* Description    : CH559غ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__attribute__((section(".romflash")))
void CH55X_IAPDownload( void )
{
    static UINT8  add_len = 0;
    static UINT8  write_len = 0;
    static UINT8  read_buf[116];
    static UINT8  iap_write[116] = {0xFF};
    UINT8  s;
    UINT16 i;
    UINT8  len;
    UINT16 tempdata;
    UINT32 addr;
    if(iap_flag)
    {
        PFIC_DisableIRQ(USBHS_IRQn);
        iap_flag = 0;
        s = 1;
        switch( iap_buf[0] )                                            // 
        {
        case CMD_IAP_PROM:                                              // ISP 
            len = iap_p_prog->len;
            addr = (iap_p_prog->addr[0] | (UINT32)iap_p_prog->addr[1]<<8 | (UINT32)iap_p_prog->addr[2]<<16 | (UINT32)iap_p_prog->addr[3]<<24);
            addr += USER_ProgrameStartAddr;

            if((addr>=USER_ProgrameStartAddr)&&(addr<=USER_ProgrameEndAddr-128))
            {
                if((prog_count%2)==0)
                {
                    stay_to_check = 1;
                    memcpy( iap_write, &iap_buf[6], len);
                    write_len = len;
                    s = 0;
                    prog_count++;
                    addr_last = addr;
                }
                else
                {
                    stay_to_check = 0;
                    memcpy( &iap_write[58], &iap_buf[6], len);
                    write_len += len;
                    add_len = 0;
                    /* 116ֽڳȵĲҪ0 */
                    if(write_len<116)
                    {
                        /* Ҫ0ĳ */
                        add_len = 4-(write_len%4);
                        if(add_len == 4)
                            add_len = 0;
                        /* Ի0 */
                        for(i=0;i<add_len;i++)
                            iap_write[write_len+i] = 0;
                        i = 0;
                    }
                    s = FLASH_ROMA_WRITE( addr_last, iap_write, write_len+add_len );
                    write_len = 0;
                    if( s!=0 )
                    {
                        printf( "addr %04X\n", addr_last );
                        printf( "p%02X\n",s );
                        break;
                    }
                    s = 0;
                    prog_count++;
                }
            }
            ch569_iap_respond(s);
            break;
        case CMD_IAP_ERASE:             // ISP 
            addr = (iap_p_erase->addr[0] | (UINT32)iap_p_erase->addr[1]<<8 | (UINT32)iap_p_erase->addr[2]<<16 | (UINT32)iap_p_erase->addr[3]<<24);
            addr += USER_ProgrameStartAddr;
            printf( "ea : %08X\n", addr );
            /* Ӵ˵ַһԲ4K */
            if((addr>=USER_ProgrameStartAddr)&&(addr<=USER_ProgrameEndAddr))
            {
                s = FLASH_ROMA_ERASE( USER_ProgrameStartAddr, 0x65000 );
                if( s!=0 )
                {
                    printf( "addr %04X\n", USER_ProgrameStartAddr );
                    printf( "s%02X\n", s );
                    break;
                }
            }
            /* ־ */
            s = FLASH_ROMA_ERASE( UESR_SEQ_ADDR, EEPROM_BLOCK_SIZE );
            if( s!=0 )
            {
                printf( "addr %04X\n", UESR_SEQ_ADDR );
                printf( "s%02X\n", s );
                break;
            }
            ch569_iap_respond(s);
            break;
        case CMD_IAP_VERIFY:                                             // ISP У
            if(stay_to_check==1)
            {
                stay_to_check = 0;
                /* Ҫ0ĳ */
                add_len = 4-(write_len%4);
                if(add_len==4) add_len = 0;
                /* Ի0 */
                for(i=0;i<add_len;i++)
                    iap_write[write_len+i] = 0;
                i = 0;
                /* Ҫдһ addr_last */
                s = FLASH_ROMA_WRITE( addr_last, iap_write, write_len+add_len );
                if( s!=0 )
                {
                    printf( "addr %04X\n", addr_last );
                    printf( "p%02X\n",s );
                    break;
                }
            }
            len = iap_p_verify->len;
            addr = (iap_p_verify->addr[0] | (UINT32)iap_p_verify->addr[1]<<8 | (UINT32)iap_p_verify->addr[2]<<16 | (UINT32)iap_p_verify->addr[3]<<24);
            addr += USER_ProgrameStartAddr;
            if((addr>=USER_ProgrameStartAddr)&&(addr<=FLASH_ROM_MAX_SIZE-128))
            {
                if((vrfy_count%2)==0)
                {
                    memcpy( iap_write, &iap_buf[6], len);
                    write_len = len;
                    s = 0;
                    vrfy_count++;
                    /* Уһ */
                    add_len = 0;
                    if(vrfy_count==prog_count)
                    {
                        /* Ҫ0ĳ */
                        add_len = 4-(write_len%4);
                        if(add_len==4) add_len = 0;
                        /* Ի0 */
                        for(i=0;i<add_len;i++)
                            iap_write[write_len+i] = 0;
                        i = 0;
                        s = FLASH_ROMA_VERIFY( addr, iap_write, write_len+add_len );
                        if( s!=0 )
                        {
                            printf( "addr %04X\n", addr );
                            printf( "p%02X\n",s );
                            break;
                        }
                    }
                    addr_last = addr;
                }
                else
                {
                    memcpy( &iap_write[58], &iap_buf[6], len);
                    vrfy_count++;
                    write_len += len;
                    add_len = 0;
                    /* 116ֽڳȵĲҪ0 */
                    if(write_len<116)
                    {
                        /* Ҫ0ĳ */
                        add_len = 4-(write_len%4);
                        if(add_len == 4)
                            add_len = 0;
                        /* Ի0 */
                        for(i=0;i<add_len;i++)
                            iap_write[write_len+i] = 0;
                        i = 0;
                    }
                    s = FLASH_ROMA_VERIFY( addr_last, iap_write, write_len+add_len );
                    if( s!=0 )
                    {
                        printf( "p%02X\n",s );
                        for(i=0;i<write_len+add_len;i++)
                            printf("%02x ",iap_write[i]);
                        printf("\n");
                        //read_buf
                        s = FLASH_ROMA_READ(addr_last,read_buf,write_len+add_len);
                        if( s!=0 )
                        {
                            printf( "rp%02X\n",s );
                        }
                        for(i=0;i<write_len+add_len;i++)
                            printf("%02x ",read_buf[i]);
                        printf("\n");
                        break;
                    }
                    s = 0;
                    write_len = 0;
                    stay_to_check = 0;
                }
            }
            ch569_iap_respond(0);
            break;
        case CMD_IAP_END:                                                // ISP 
            //stop flag ,jump to user code
            printf( "CMD_IAP_END\n" );
            //req_queue
            memcpy( iap_write, ( UINT8* )req_queue, 24 );
            s = FLASH_ROMA_WRITE( UESR_SEQ_ADDR, iap_write, 24 );
            if( s!=0 )
            {
                printf( "p%02\n", s );
            }
            s = FLASH_ROMA_VERIFY( UESR_SEQ_ADDR, iap_write, 24 );
            if( s!=0 )
            {
                printf( "p%02\n", s );
                for(i=0;i<24;i++)
                        printf("%02x ",req_queue[i]);
                    printf("\n");
                    //read_buf
                    s = FLASH_ROMA_READ(addr_last,read_buf,24);
                    if( s!=0 )
                    {
                        printf( "rp%02X\n",s );
                    }
                    for(i=0;i<24;i++)
                        printf("%02x ",read_buf[i]);
                    printf("\n");
                    break;
            }
            else
            {
                /* ȷϱ־дɹ */
                USBHS->UEP2_CTRL = EP_R_AUTOTOG|EP_R_RES_ACK|0;
                ch569_iap_respond(0);
                printf( "req_queue confirmed\n" );
            }
            i = 0x55aa;
            break;
        case CMD_IAP_SUCCESS:
            printf( "CMD_IAP_SUCCESS\n" );
            ch569_iap_respond(0);
            break;
        default:
            printf("unsupport\n");                                     // δ֪
            ch569_iap_respond(0xFE);
            break;
        }
        PFIC_EnableIRQ(USBHS_IRQn);
    }
    if(i==0x55aa)
    {
        PRINT("User Code!\n");
        DelayMs(100);
        iap_end = 1;
        PFIC_DisableIRQ( USBHS_IRQn );

        /* дR8_GLOB_RESET_KEEPĴΪλǷתû */
        R8_GLOB_RESET_KEEP = 0xAA;
        /* Software Reset */
        SYS_ResetExecute( );

    }
}

PUINT8 pdescv          = NULL;
volatile BOOL  tog     = 0;
BOOL   EP1_TOG         = 0;
UINT8  send_data_len   = 0;
UINT8  UsbConfig       = 0;
#define ep0_send_size        64
#define USBHS_SETUP_REQ_BUF  ((PUSB_SETUP_REQ)endp0RTbuff)
UINT8  WakeUpEnFlag = 0;
UINT16 SetupLen = 0;
/*******************************************************************************
* Function Name  : USBHS_IRQHandler
* Description    : USB2.0 Interrupt Handler.
* Input          : None
* Return         : None
*******************************************************************************/
void USBHS_IRQHandler(void)			//USBHS interrupt severice
{
    UINT8  bRequestType;
    UINT8  bRequest;
    UINT8  wValue_l;
    UINT8  wValue_h;
    UINT16 wLength;
    UINT8  wIndex_l;
    UINT8  wIndex_h;
    UINT8  tx_len;
    UINT32 end_num;
    UINT32 rx_token;
    UINT8  i;
    UINT8  rx_len;
    if( USBHS->USB_STATUS & USB2_SETUP_FLAG )
    {
        USBHS->UEP0_CTRL = 0;
        bRequestType = endp0RTbuff[0];//USBHS_SETUP_REQ_BUF->bRequestType;
        bRequest     = endp0RTbuff[1];//USBHS_SETUP_REQ_BUF->bRequest;
        wValue_l     = endp0RTbuff[2];//(UINT8)((USBHS_SETUP_REQ_BUF->wValue)&0xFF);
        wValue_h     = endp0RTbuff[3];//(UINT8)((USBHS_SETUP_REQ_BUF->wValue)>>8);
        wIndex_l     = endp0RTbuff[4];//(UINT8)((USBHS_SETUP_REQ_BUF->wIndex)&0xFF);
        wIndex_h     = endp0RTbuff[5];//(UINT8)((USBHS_SETUP_REQ_BUF->wIndex)>>8);
        wLength      = (UINT16)endp0RTbuff[6]+(UINT16)(endp0RTbuff[7]<<8);//USBHS_SETUP_REQ_BUF->wLength;
        printf( "%02X ", bRequestType );
        printf( "%02X ", bRequest );
        printf( "%02X ", wValue_l );
        printf( "%02X ", wValue_h );
        printf( "%02X ", wIndex_l );
        printf( "%02X ", wIndex_h );
        printf( "%d\n",  wLength );
        if( (bRequestType&USB_REQ_TYP_MASK) != USB_REQ_TYP_STANDARD )/* HID */
        {
            switch( bRequest )
            {
            case 0x01://GetReport
                printf( "GetReport\n" );
                USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 |0;
                break;
            case 0x02://GetIdle
                break;
            case 0x03://GetProtocol
                break;
            case 0x09://SetReport
                printf( "SetReport\n" );
                USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 |0;
                break;
            case 0x0A://SetIdle
                printf( "SetIdle\n" );
                USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 |0;
                break;
            case 0x0B://SetProtocol
                break;
            default:
                break;
            }
        }
        else
        {
            switch( bRequest )
            {
            case 0x06://get descriptor
                if( wValue_h == 0x01 )//device descriptor
                {
                    if( wLength >= hs_device_descriptor[0] ) get_config_status = hs_device_descriptor[0];
                    else get_config_status = wLength;
                    pdescv = (PUINT8)hs_device_descriptor;
                }
                else if( wValue_h == 0x02 )//configuration descriptor
                {
                    if( wLength >= hs_config_descriptor[2] ) get_config_status = hs_config_descriptor[2];
                    else get_config_status = wLength;
                    pdescv = (PUINT8)hs_config_descriptor;
                }
                else if( wValue_h == 0x03 )//string descriptor
                {
                    if( wValue_l == 0x00 )
                    {
                        if( wLength >= hs_string_descriptor0[0] ) get_config_status = hs_string_descriptor0[0];
                        else get_config_status = wLength;
                        pdescv = (PUINT8)hs_string_descriptor0;
                        printf("03\n");
                    }
                    else if( wValue_l == 0x01 )
                    {
                        if( wLength >= hs_string_descriptor1[0] ) get_config_status = hs_string_descriptor1[0];
                        else get_config_status = wLength;
                        pdescv = (PUINT8)hs_string_descriptor1;
                        printf("13\n");
                    }
                    else if( wValue_l == 0x02 )
                    {
                        if( wLength >= hs_string_descriptor2[0] ) get_config_status = hs_string_descriptor2[0];
                        else get_config_status = wLength;
                        pdescv = (PUINT8)hs_string_descriptor2;
                        printf("23\n");
                    }
                }
                else if( wValue_h == 0x22 )//report descriptor
                {
                    ;
                }
                else if( wValue_h == 0x0f )//bos descriptor
                {
                    ;
                }
                if( get_config_status > ep0_send_size ) tx_len = ep0_send_size;
                else tx_len = get_config_status;
                memcpy( endp0RTbuff, pdescv, tx_len );
                get_config_status -= tx_len;
                pdescv += tx_len;
                USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 | (UINT16)tx_len; // DATA stage (IN -DATA1-ACK)
                tog = 0;
                break;
            case 0x05://set address
                set_address_status = 1;
                device_addr = wValue_l;
                USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 |0; // IN -DATA1-ACK( len =0 )
                break;
            case 0x08://get configuration
                endp0RTbuff[0] = UsbConfig;
                USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 | 1; // DATA stage (IN -DATA1-ACK)
                break;
            case 0x09://set configuration
                UsbConfig = wValue_l;
                USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 | 0; // IN -DATA1-ACK( len =0 )
                break;
            case 0x01://clear feature
                if ( ( bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )// ˵
                {
                    printf( "clear feature,clear endp\n" );
                    USBHS->UEP0_CTRL = EP_T_TOG_1 | UEP_T_RES_ACK | 0;
                }
                else if ( ( bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_DEVICE )// 豸
                {
                    printf("Wake up\n");
                    USBHS->UEP0_CTRL = EP_T_TOG_1 | UEP_T_RES_ACK | 0;
                    break;
                }
                else
                {
                    USBHS->UEP0_CTRL = EP_T_TOG_1 | EP_R_TOG_1 | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL
                }
                break;
            case 0x03://set feature
                if( ( bRequestType & 0x1F ) == 0x00 )              /* 豸 */
                {
                    if( ( ( ( UINT16 )wValue_h << 8 ) | wValue_l ) == 0x01 )
                    {
                        if( hs_config_descriptor[ 7 ] & 0x20 )
                        {
                            WakeUpEnFlag = 1;                                   /* ûʹܱ־ */
                            USBHS->UEP0_CTRL = EP_T_TOG_1 | UEP_T_RES_ACK | 0;
                            printf("Enable Remote Wakeup.\n");
                        }
                        else
                        {
                            USBHS->UEP0_CTRL = EP_T_TOG_1 | EP_R_TOG_1 | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL/* ʧ */
                        }
                    }
                    else
                    {
                        USBHS->UEP0_CTRL = EP_T_TOG_1 | EP_R_TOG_1 | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL/* ʧ */
                    }
                }
                else if( ( bRequestType & 0x1F ) == 0x02 )        /* ö˵ */
                {
                    switch( wIndex_l )
                    {
                    case 0x01:
                        USBHS->UEP1_CTRL = (USBHS->UEP1_CTRL&(~EP_T_TOG_1)) | UEP_R_RES_STALL;
                        break;
                    case 0x81:
                        USBHS->UEP1_CTRL = (USBHS->UEP1_CTRL&(~EP_T_TOG_1)) | UEP_T_RES_STALL;
                        break;
                    default:
                        USBHS->UEP0_CTRL = EP_T_TOG_1 | EP_R_TOG_1 | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL
                        break;
                    }
                }
                else
                {
                    USBHS->UEP0_CTRL = EP_T_TOG_1 | EP_R_TOG_1 | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL/* ʧ */
                }
                break;
            case 0x00://get status
                endp0RTbuff[0] = 0;
                endp0RTbuff[0] = 0;
                USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 | 2; // DATA stage (IN -DATA1-ACK)
                break;
            case 0x0A://get interface
                endp0RTbuff[0] = 0;
                USBHS->UEP0_CTRL = EP_R_RES_ACK | EP_R_TOG_1 | EP_T_RES_ACK | EP_T_TOG_1 | 0;
                break;
            case 0x07://set Descriptor
                break;
            case 0x0B://set interface
                break;
            case 0x0C://synch_frame
                break;
            default:
                break;
            }
        }
        USBHS->USB_STATUS = USB2_SETUP_FLAG;
    }
    else if( USBHS->USB_STATUS & USB2_ACT_FLAG )
    {
        end_num =  ((USBHS->USB_STATUS)>>24) & 0xf;
        rx_token = ((USBHS->USB_STATUS)>>28) & 0x3; // 00: OUT, 01:SOF, 10:IN, 11:SETUP
        if( end_num == 0 )
        {
            if( rx_token == PID_IN )
            {
//                USBHS->UEP2_CTRL  = EP_T_RES_NAK|EP_R_RES_ACK|EP_R_TOG_1;
                if( set_address_status )
                {
                     USB20_Device_Setaddress( device_addr );// SET ADDRESS
                     set_address_status = 0;
                     USBHS->UEP0_CTRL = 0;
                }
                else if( get_config_status )
                {
                    if( get_config_status > ep0_send_size ) tx_len = ep0_send_size;
                    else tx_len = get_config_status;
                    memcpy( endp0RTbuff, pdescv, tx_len );
                    pdescv += tx_len;
                    get_config_status -= tx_len;
                    if(tog)
                    {
                         USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_1 | tx_len;
                         tog = 0;
                         printf( "tog 1\n" );
                    }
                    else
                    {
                        USBHS->UEP0_CTRL = EP_T_RES_ACK | EP_T_TOG_0 | tx_len;
                        tog = 1;
                        printf( "tog 0\n" );
                    }
                }
                else
                {
                    get_config_status = 0;
                    pdescv = NULL;
                    tx_len = 0;
                    USBHS->UEP0_CTRL = EP_R_RES_ACK | EP_R_TOG_1;
                }
            }
            else if( rx_token == PID_OUT )
            {
                USBHS->UEP0_CTRL = EP_T_RES_NAK | EP_R_RES_ACK;
            }
        }

        else if( end_num == 2 )
        {
            if( rx_token == PID_IN )
            {

            }
            else if( rx_token == PID_OUT )
            {
                rx_len = USBHS->USB_RX_LEN;
                memcpy( iap_buf, endp2RTbuff, rx_len );
                if( iap_buf[0]==0x80 || iap_buf[0]==0x81 || iap_buf[0]==0x82 || iap_buf[0]==0x83 )
                {
                    iap_flag = 1;
                }
            }
        }
        else if( end_num == 3 )
        {

            if( rx_token == PID_IN )
            {
                USBHS->UEP2_CTRL = EP_R_AUTOTOG|EP_R_RES_ACK|0;
                USBHS->UEP3_CTRL = EP_T_TOG_0|EP_T_RES_NAK|0;
            }
        }
        USBHS->USB_STATUS = USB2_ACT_FLAG;
    }
    else if( USBHS->USB_STATUS & USB2_DETECT_FLAG )
    {
        device_addr = 0;
        USB20_Endp_Init( );
        USB20_Device_Setaddress( device_addr );
        printf(" bus reset! \n");
        USBHS->USB_STATUS = USB2_DETECT_FLAG;
    }
    else if(USBHS->USB_STATUS & USB2_SUSP_FLAG )
    {
        printf( "bus suspend\n" );
        USBHS->USB_STATUS = USB2_SUSP_FLAG;
    }
}
